﻿Object subclass: #Dota
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Dota commentStamp: '<historical>' prior: 0!
Represents the main class of the game.!


Dota subclass: #GameArena
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!GameArena commentStamp: '<historical>' prior: 0!
Main class of the game.!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GameArena class
	instanceVariableNames: ''!

!GameArena class methodsFor: 'starting' stamp: 'BerkErol 5/17/2017 09:27'!
start
	"starts the whole game"

	| player1 player2 count |
	player1 := Player new.
	player2 := Player new.
	player1 name: 'Player1'.
	player2 name: 'Player2'.
	player1 fight takeHero: self chooseScourge.
	player2 fight takeHero: self chooseSentinel.
	self shop: player1.
	self shop: player2.
	self viewInventory: player1.
	self viewInventory: player2.
	self useItems: player1.
	self useItems: player2.
	player1 fight hero skill1 name = 'Blur'
		ifTrue: [ player1 effects evasion: player1 effects evasion + 40 ].
	count := 0.
	[ player1 fight hp > 0 and: player2 fight hp > 0 ]
		whileTrue: [ count := count + 1.
			count % 2 = 1
				ifTrue: [ self viewTurnHeader: player1.
					self viewPlayers: player1 and: player2.
					self fight: player1 with: player2.
					self updateCounts: player1 ]
				ifFalse: [ self viewTurnHeader: player2.
					self viewPlayers: player1 and: player2.
					self fight: player2 with: player1.
					self updateCounts: player2 ] ].
	self viewEnds: player1 and: player2! !


!GameArena class methodsFor: 'editing' stamp: 'BerkErol 5/17/2017 09:35'!
skill: effects to: enemyPlayer
	"apply active skills' effects to enemy player"

	| decHP decMana |
	decHP := ((100 - enemyPlayer effects decSkill) * (effects at: 1) / 100) rounded.
	decMana := effects at: 2.
	enemyPlayer fight hp - decHP > 0
		ifTrue: [ enemyPlayer fight hp: enemyPlayer fight hp - decHP ]
		ifFalse: [ enemyPlayer fight hp: 0 ].
	enemyPlayer fight mana - decMana > 0
		ifTrue: [ enemyPlayer fight mana: enemyPlayer fight mana - decMana ]
		ifFalse: [ enemyPlayer fight mana: 0 ]! !

!GameArena class methodsFor: 'editing' stamp: 'BerkErol 5/15/2017 22:28'!
makeFightList: player
	"makes a list for the actions that players can choose for fight then returns it"

	| list hero |
	list := LinkedList new.
	list add: 'Attack'.
	player inventory health isEmpty
		ifFalse: [ list add: 'Health Potion' ].
	player inventory mana isEmpty
		ifFalse: [ list add: 'Mana Potion' ].
	hero := player fight hero.
	player fight mana >= hero skill1 mana
		ifTrue: [ hero skill1 count = 0
				ifTrue: [ hero skill1 type
						ifTrue: [ list add: hero skill1 name ] ] ].
	hero skill2 name = 'Pulse Nova'
		ifTrue: [ hero skill2 type
				ifFalse: [ list add: hero skill2 name ] ]
		ifFalse: [ player fight mana >= hero skill2 mana
				ifTrue: [ hero skill2 count = 0
						ifTrue: [ hero skill2 type
								ifTrue: [ list add: hero skill2 name ] ] ] ].
	^ list! !

!GameArena class methodsFor: 'editing' stamp: 'BerkErol 5/17/2017 09:26'!
fight: player1 with: player2
	"enables players to fight with each other"

	| yesno list message action potion |
	player1 fight hero skill2 name = 'Pulse Nova'
		ifTrue: [ player1 fight hero skill2 type
				ifTrue: [ yesno := LinkedList new.
					yesno add: 'Yes'.
					yesno add: 'No'.
					(yesno at: (UIManager default chooseFrom: yesno message: 'Do you want to deactivate Pulse Nova?' title: 'Pulse Nova')) = 'Yes'
						ifTrue: [ player1 fight hero skill2 deactivate ] ] ].
	message := player1 name , '`s turn!! (' , player1 fight hero name , ')'.
	list := self makeFightList: player1.
	action := list at: (UIManager default chooseFrom: list message: message title: 'Choose').
	action = 'Attack'
		ifTrue: [ player1 fight lastAction: 'Attack'.
			player1 fight hero skill1 name = 'Mana Break'
				ifTrue: [ player2 fight mana: player2 fight mana - 100 ].
			self attack: player1 to: player2 ].
	action = 'Health Potion'
		ifTrue: [ potion := player1 inventory health removeFirst.
			player1 fight hp + potion hp < player1 fight hero hp
				ifTrue: [ player1 fight hp: player1 fight hp + potion hp ]
				ifFalse: [ player1 fight hp: player1 fight hero hp ].
			player1 fight lastAction: 'Health Potion' ].
	action = 'Mana Potion'
		ifTrue: [ potion := player1 inventory mana removeFirst.
			player1 fight mana + potion mana < player1 fight hero mana
				ifTrue: [ player1 fight mana: player1 fight mana + potion mana ]
				ifFalse: [ player1 fight mana: player1 fight hero mana ].
			player1 fight lastAction: 'Mana Potion' ].
	action = player1 fight hero skill1 name
		ifTrue: [ self skill: (player1 fight hero skill1 use: player2) to: player2.
			player1 fight mana: player1 fight mana - player1 fight hero skill1 mana.
			player1 fight hero skill1 count: player1 fight hero skill1 count + player1 fight hero skill1 cooldown + 1.
			player1 fight lastAction: player1 fight hero skill1 name ].
	action = player1 fight hero skill2 name
		ifTrue: [ player1 fight hero skill2 name = 'Pulse Nova'
				ifTrue: [ player1 fight hero skill2 activate.
					player1 fight lastAction: 'Activate Pulse Nova' ]
				ifFalse: [ self skill: (player1 fight hero skill2 use: player2) to: player2.
					player1 fight mana: player1 fight mana - player1 fight hero skill2 mana.
					player1 fight hero skill2 count: player1 fight hero skill2 count + player1 fight hero skill2 cooldown + 1.
					player1 fight lastAction: player1 fight hero skill2 name ] ].
	player1 fight hero skill2 name = 'Pulse Nova'
		ifTrue: [ player1 fight hero skill2 type
				ifTrue: [ player1 fight mana - player1 fight hero skill2 mana > 0
						ifTrue: [ player2 fight hp - player1 fight hero skill2 damage > 0
								ifTrue: [ player2 fight hp: player2 fight hp - player1 fight hero skill2 damage ]
								ifFalse: [ player2 fight hp: 0 ].
							player1 fight mana: player1 fight mana - player1 fight hero skill2 mana ] ] ]! !

!GameArena class methodsFor: 'editing' stamp: 'BerkErol 5/9/2017 19:55'!
updateCounts: player
	"updates hero skill cooldown and hp & mana increase from items"

	| inc |
	player fight hero skill1 count > 0
		ifTrue: [ player fight hero skill1 count: player fight hero skill1 count - 1 ].
	player fight hero skill2 count > 0
		ifTrue: [ player fight hero skill2 count: player fight hero skill2 count - 1 ].
	player fight mana + player effects manaAlways < player fight hero mana
		ifTrue: [ player fight mana: player fight mana + player effects manaAlways ]
		ifFalse: [ player fight mana: player fight hero mana ].
	inc := (player fight hp * 7 / 100) rounded * player effects hp7p.
	player fight hp + inc < player fight hero hp
		ifTrue: [ player fight hp: player fight hp + inc ]
		ifFalse: [ player fight hp: player fight hero hp ]! !

!GameArena class methodsFor: 'editing' stamp: 'BerkErol 5/15/2017 20:46'!
useItems: player
	"enables players to use their items"

	player inventory items do: [ :item | item use: player ].
	player fight hero minDamage: player fight hero minDamage + player effects minDamage.
	player fight hero maxDamage: player fight hero maxDamage + player effects maxDamage.
	player fight hero armor: player fight hero armor + player effects armor.
	player fight hp: player fight hp + player effects hp.
	player fight hero hp: player fight hero hp + player effects hp.
	player fight mana: player fight mana + player effects mana.
	player fight hero mana: player fight hero mana + player effects mana! !

!GameArena class methodsFor: 'editing' stamp: 'BerkErol 5/17/2017 09:11'!
attack: player to: enemyPlayer
	"attacks to the enemy"

	| attack skillMultiply givenDamage actualDamage itemDec skillDec |
	(Random new nextInt: 100) < enemyPlayer effects evasion
		ifTrue: [ ^ self ].
	attack := player fight hero attack.
	skillMultiply := (Random new nextInt: 100) < player effects critic
		ifTrue: [ attack * 2 ]
		ifFalse: [ attack ].
	player fight hero skill2 name = 'Enchant Totem'
		ifTrue: [ player fight hero skill2 dcount > 0
				ifTrue: [ givenDamage := skillMultiply * player fight hero skill2 damage.
					player fight hero skill2 dcount: player fight hero skill2 dcount - 1 ]
				ifFalse: [ givenDamage := skillMultiply ] ]
		ifFalse: [ player fight hero skill2 name = 'Gods Strength'
				ifTrue: [ player fight hero skill2 dcount > 0
						ifTrue: [ givenDamage := skillMultiply * player fight hero skill2 damage.
							player fight hero skill2 dcount: player fight hero skill2 dcount - 1 ]
						ifFalse: [ givenDamage := skillMultiply ] ]
				ifFalse: [ givenDamage := skillMultiply ] ].
	actualDamage := (givenDamage * (1 - (0.06 * enemyPlayer fight hero armor / (1 + (0.06 * enemyPlayer fight hero armor))))) rounded.
	itemDec := (Random new nextInt: 100) < enemyPlayer effects dec60
		ifTrue: [ actualDamage - 60 ]
		ifFalse: [ actualDamage ].
	enemyPlayer fight hero skill1 name = 'Anchor Smash'
		ifTrue: [ enemyPlayer fight hero skill1 dcount > 0
				ifTrue: [ skillDec := itemDec * enemyPlayer fight hero skill1 defense.
					enemyPlayer fight hero skill1 dcount: enemyPlayer fight hero skill1 dcount - 1 ]
				ifFalse: [ skillDec := itemDec ] ]
		ifFalse: [ skillDec := itemDec ].
	enemyPlayer fight hp - skillDec > 0
		ifTrue: [ enemyPlayer fight hp: enemyPlayer fight hp - skillDec ]
		ifFalse: [ enemyPlayer fight hp: 0 ].
	enemyPlayer fight hero skill2 name = 'Vampiric Aura'
		ifTrue: [ enemyPlayer fight hp: enemyPlayer fight hp + (skillDec * 15 / 100) rounded ]! !

!GameArena class methodsFor: 'editing' stamp: 'BerkErol 5/1/2017 11:21'!
makeShopList: player
	"makes a list from the items and potions that players can buy then returns it"

	| list |
	list := LinkedList new.
	list := self addItem: BattleFury new forPlayer: player toShopList: list.
	list := self addItem: Butterfly new forPlayer: player toShopList: list.
	list := self addItem: Daedalus new forPlayer: player toShopList: list.
	list := self addItem: Desolator new forPlayer: player toShopList: list.
	list := self addItem: EnergyBooster new forPlayer: player toShopList: list.
	list := self addItem: HealthPotion new forPlayer: player toShopList: list.
	list := self addItem: HeartOfTarrasque new forPlayer: player toShopList: list.
	list := self addItem: HoodOfDefiance new forPlayer: player toShopList: list.
	list := self addItem: ManaPotion new forPlayer: player toShopList: list.
	list := self addItem: Vanguard new forPlayer: player toShopList: list.
	list := self addItem: VitalityBooster new forPlayer: player toShopList: list.
	^ list! !

!GameArena class methodsFor: 'editing' stamp: 'BerkErol 5/17/2017 09:37'!
shop: player
	"enables players to buy items and potions"

	| list item |
	list := self makeShopList: player.
	[ player inventory slot >= 0.5 and: (player inventory gold >= 200 and: list size ~= 0) ]
		whileTrue: [ item := self chooseItemForPlayer: player fromList: list.
			player inventory buy: item.
			player inventory addItem: item.
			list := self makeShopList: player.
			Transcript
				show: 'Remaining gold for ';
				show: player name;
				show: ' : ';
				show: player inventory gold asString;
				cr ]! !


!GameArena class methodsFor: 'displaying' stamp: 'BerkErol 4/21/2017 22:57'!
viewEnds: player1 and: player2
	"prints the end of game"

	self viewPlayers: player1 and: player2.
	player1 fight hp > 0
		ifTrue: [ self viewEnd: player1 ]
		ifFalse: [ self viewEnd: player2 ]! !

!GameArena class methodsFor: 'displaying' stamp: 'BerkErol 4/21/2017 22:36'!
viewSkillsInCooldown: player
	"returns string containing information about skills in cooldown"

	| skill1 skill2 message |
	message := ''.
	skill1 := player fight hero skill1.
	skill1 count > 0
		ifTrue: [ message := message , skill1 name , ' (not available for ' , skill1 count asString , ' turns)' ].
	skill2 := player fight hero skill2.
	skill2 count > 0
		ifTrue: [ skill1 count > 0
				ifTrue: [ message := message , ', ' ].
			message := message , skill2 name , ' (not available for ' , skill2 count asString , ' turns)' ].
	message = ''
		ifTrue: [ message := 'None' ].
	^ 'Skills in Cooldown: ' , message! !

!GameArena class methodsFor: 'displaying' stamp: 'BerkErol 4/21/2017 11:30'!
viewPlayers: player1 and: player2
	"prints players information"

	self viewPlayer: player1.
	self viewPlayer: player2! !

!GameArena class methodsFor: 'displaying' stamp: 'BerkErol 4/21/2017 11:18'!
viewInventory: player
	"prints player inventory"

	Transcript
		show: player inventory items;
		cr! !

!GameArena class methodsFor: 'displaying' stamp: 'BerkErol 5/9/2017 19:32'!
viewRemainingPotions: player
	"returns string containing information about the numbers of potion types"

	| message health mana |
	message := ''.
	health := player inventory health size.
	mana := player inventory mana size.
	health ~= 0
		ifTrue: [ message := message , health asString , ' Health' ].
	mana ~= 0
		ifTrue: [ health ~= 0
				ifTrue: [ message := message , ', ' ].
			message := message , mana asString , ' Mana' ].
	message = ''
		ifTrue: [ message := 'None' ].
	^ 'Remaining Potions: ' , message! !

!GameArena class methodsFor: 'displaying' stamp: 'BerkErol 4/21/2017 11:33'!
viewEnd: player
	"prints the winner of the game"

	Transcript
		show: player name;
		show: ' (';
		show: player fight hero name;
		show: ') is the winner of the game !!!!!!'! !

!GameArena class methodsFor: 'displaying' stamp: 'BerkErol 5/15/2017 22:19'!
viewPlayer: player
	"prints player information"

	Transcript
		show: player name;
		cr;
		show: 'Hero: ';
		show: player fight hero name;
		cr;
		show: player fight hp asString;
		show: ' / ';
		show: player fight hero hp asString;
		show: ' HP';
		cr;
		show: player fight mana asString;
		show: ' / ';
		show: player fight hero mana asString;
		show: ' Mana';
		cr;
		show: 'Last Action: ';
		show: player fight lastAction;
		cr;
		show: (self viewRemainingPotions: player);
		cr;
		show: (self viewSkillsInCooldown: player);
		cr;
		show: player fight hero skill2 type;
		cr! !

!GameArena class methodsFor: 'displaying' stamp: 'BerkErol 4/21/2017 11:27'!
viewTurnHeader: player
	"prints whose turn this turn is"

	Transcript
		show: player name;
		show: '`s turn!!';
		cr! !


!GameArena class methodsFor: 'choosing' stamp: 'BerkErol 4/29/2017 16:20'!
addItem: item forPlayer: player toShopList: list
	"adds an item or a potion to the list"

	player inventory slot >= item slot
		ifTrue: [ player inventory gold >= item cost
				ifTrue: [ list add: item name ] ].
	^ list! !

!GameArena class methodsFor: 'choosing' stamp: 'BerkErol 5/17/2017 09:38'!
chooseScourge
	"enables Player 1 to choose a Scourge Hero then returns it"

	| list message hero |
	list := #('Leshrac' 'Lion' 'Mortred' 'Nyx Assassin' 'Skeleton King' 'Tidehunter').
	message := 'Player1: Choose a Scourge hero'.
	hero := list at: (UIManager default chooseFrom: list message: message title: 'Choose').
	hero = 'Leshrac'
		ifTrue: [ ^ Leshrac new ].
	hero = 'Lion'
		ifTrue: [ ^ Lion new ].
	hero = 'Mortred'
		ifTrue: [ ^ Mortred new ].
	hero = 'Nyx Assassin'
		ifTrue: [ ^ NyxAssassin new ].
	hero = 'Skeleton King'
		ifTrue: [ ^ SkeletonKing new ].
	hero = 'Tidehunter'
		ifTrue: [ ^ Tidehunter new ]! !

!GameArena class methodsFor: 'choosing' stamp: 'BerkErol 5/17/2017 09:38'!
chooseSentinel
	"enables Player 2 to choose a Sentinel Hero then returns it"

	| list message hero |
	list := #('Earthshaker' 'Magina' 'Mirana' 'Ogre Magi' 'Rylai' 'Sven').
	message := 'Player2: Choose a Sentinel hero'.
	hero := list at: (UIManager default chooseFrom: list message: message title: 'Choose').
	hero = 'Earthshaker'
		ifTrue: [ ^ Earthshaker new ].
	hero = 'Magina'
		ifTrue: [ ^ Magina new ].
	hero = 'Mirana'
		ifTrue: [ ^ Mirana new ].
	hero = 'Ogre Magi'
		ifTrue: [ ^ OgreMagi new ].
	hero = 'Rylai'
		ifTrue: [ ^ Rylai new ].
	hero = 'Sven'
		ifTrue: [ ^ Sven new ]! !

!GameArena class methodsFor: 'choosing' stamp: 'BerkErol 5/17/2017 09:39'!
chooseItemForPlayer: player fromList: list
	"enables players to choose an item then returns it"

	| message item |
	message := 'Choose an item for ', player name, ' (remaining item slot = ', player inventory slot asString, ', remaining gold = ', player inventory gold asString, ')'.
	item := list at: (UIManager default chooseFrom: list message: message title: 'Choose').
	item = 'Battle Fury'
	ifTrue: [ ^ BattleFury new ].
	item = 'Butterfly'
	ifTrue: [ ^ Butterfly new ].
	item = 'Daedalus'
	ifTrue: [ ^ Daedalus new ].
	item = 'Desolator'
	ifTrue: [ ^ Desolator new ].
	item = 'Energy Booster'
	ifTrue: [ ^ EnergyBooster new ].
	item = 'Health Potion'
	ifTrue: [ ^ HealthPotion new ].
	item = 'Heart of Tarrasque'
	ifTrue: [ ^ HeartOfTarrasque new ].
	item = 'Hood of Defiance'
	ifTrue: [ ^ HoodOfDefiance new ].
	item = 'Mana Potion'
	ifTrue: [ ^ ManaPotion new ].
	item = 'Vanguard'
	ifTrue: [ ^ Vanguard new ].
	item = 'Vitality Booster'
	ifTrue: [ ^ VitalityBooster new ].! !


GameArena subclass: #Fight
	instanceVariableNames: 'hero hp mana lastAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Fight commentStamp: 'BerkErol 4/19/2017 22:47' prior: 0!
Represents fights.!


!Fight methodsFor: 'editing' stamp: 'BerkErol 5/15/2017 23:53'!
takeHero: newHero
	"sets the variables for the given hero of a Fight instance"

	hero := newHero.
	hp := newHero hp.
	mana := newHero mana.
	lastAction := 'None'! !


!Fight methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 22:52'!
mana: newMana
	"sets the mana of a Fight instance"

	mana := newMana! !

!Fight methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 22:54'!
lastAction: newLastAction
	"sets the last action of a Fight instance"

	lastAction := newLastAction! !

!Fight methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 22:51'!
hero
	"returns the hero of a Fight instance"

	^ hero! !

!Fight methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 22:52'!
hero: newHero
	"sets the hero of a Fight instance"

	hero := newHero! !

!Fight methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 22:52'!
hp: newHp
	"sets the HP of a Fight instance"

	hp := newHp! !

!Fight methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 22:53'!
lastAction
	"returns the last action of a Fight instance"

	^ lastAction! !

!Fight methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 22:52'!
hp
	"returns the HP of a Fight instance"

	^ hp! !

!Fight methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 22:52'!
mana
	"returns the mana of a Fight instance"

	^ mana! !


Dota subclass: #Hero
	instanceVariableNames: 'name side hp mana armor skill1 skill2 minDamage maxDamage'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Hero commentStamp: 'BerkErol 4/19/2017 11:16' prior: 0!
Represents heroes.!


!Hero methodsFor: 'editing' stamp: 'BerkErol 4/28/2017 23:53'!
attack
	"calcutates given damage"

	^ ((Random new nextInt: maxDamage - minDamage + 1) + minDamage - 1)! !


!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 21:34'!
skill2: newSkill2
	"sets the second skill of a Hero instance"

	skill2 := newSkill2! !

!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 11:07'!
mana
	"returns the mana of a Hero instance"

	^ mana! !

!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 11:01'!
hp: newHp
	"sets the HP of a Hero instance"

	hp := newHp! !

!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 10:48'!
name
	"returns the name of a Hero instance"

	^ name! !

!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 11:07'!
maxDamage
	"returns the max damage of a Hero instance"

	^ maxDamage! !

!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 11:01'!
name: newName
	"sets the name of a Hero instance"

	name := newName! !

!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 11:07'!
armor
	"returns the armor of a Hero instance"

	^ armor! !

!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 21:34'!
skill2
	"returns the second skill of a Hero instance"

	^ skill2! !

!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 11:08'!
maxDamage: newMaxDamage
	"sets the max damage of a Hero instance"

	maxDamage := newMaxDamage! !

!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 11:08'!
minDamage: newMinDamage
	"sets the min damage of a Hero instance"

	minDamage := newMinDamage! !

!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 21:34'!
skill1: newSkill1
	"sets the first skill of a Hero instance"

	skill1 := newSkill1! !

!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 11:08'!
mana: newMana
	"sets the mana of a Hero instance"

	mana := newMana! !

!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 11:08'!
armor: newArmor
	"sets the armor of a Hero instance"

	armor := newArmor! !

!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 11:02'!
hp
	"returns the HP of a Hero instance"

	^ hp! !

!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 21:33'!
skill1
	"returns the first skill of a Hero instance"

	^ skill1! !

!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 11:08'!
minDamage
	"returns the min damage of a Hero instance"

	^ minDamage! !

!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 11:26'!
side: newSide
	"sets the side of a Hero instance"

	side := newSide! !

!Hero methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 11:26'!
side
	"returns the side of a Hero instance"

	^ side! !


GameArena subclass: #Inventory
	instanceVariableNames: 'slot gold items health mana'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Inventory commentStamp: 'BerkErol 4/19/2017 22:27' prior: 0!
Represents inventories.!


!Inventory methodsFor: 'editing' stamp: 'BerkErol 5/9/2017 19:25'!
addItem: item
	"adds an item or a potion to an Inventory instance"

	item name = 'Health Potion'
		ifTrue: [ health add: item ]
		ifFalse: [ item name = 'Mana Potion'
				ifTrue: [ mana add: item ]
				ifFalse: [ items add: item ] ]! !

!Inventory methodsFor: 'editing' stamp: 'BerkErol 4/29/2017 16:30'!
buy: item
	"buys an item for an Inventory instance"

	gold := gold - item cost.
	slot := slot - item slot! !


!Inventory methodsFor: 'initialization' stamp: 'BerkErol 5/9/2017 19:24'!
initialize
	"Creates a new Inventory instance"

	super initialize.
	slot := 4.
	gold := 11000.
	items := LinkedList new.
	health := LinkedList new.
	mana := LinkedList new! !


!Inventory methodsFor: 'accessing' stamp: 'BerkErol 4/29/2017 16:13'!
slot
	^ slot! !

!Inventory methodsFor: 'accessing' stamp: 'BerkErol 4/29/2017 16:13'!
slot: anObject
	slot := anObject! !

!Inventory methodsFor: 'accessing' stamp: 'BerkErol 4/29/2017 16:13'!
gold
	^ gold! !

!Inventory methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 22:48'!
mana
	"returns the number of mana potions of an Inventory instance"

	^ mana! !

!Inventory methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 22:47'!
health: newHealth
	"sets the the number of health potions of an Inventory instance"

	health := newHealth! !

!Inventory methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 01:50'!
items: newItems
	"sets the items of an Inventory instance except potions"

	items := newItems! !

!Inventory methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 01:50'!
items
	"returns the items of an Inventory instance except potions"

	^ items! !

!Inventory methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 22:48'!
mana: newMana
	"sets the the number of mana potions of an Inventory instance"

	mana := newMana! !

!Inventory methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 22:47'!
health
	"returns the number of health potions of an Inventory instance"

	^ health! !

!Inventory methodsFor: 'accessing' stamp: 'BerkErol 4/29/2017 16:13'!
gold: anObject
	gold := anObject! !


Dota subclass: #Item
	instanceVariableNames: 'name slot cost'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Item commentStamp: 'BerkErol 4/19/2017 20:16' prior: 0!
Represents items.!


!Item methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 18:50'!
name: newName
	"sets the name of an Item instance"

	name := newName! !

!Item methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 18:46'!
cost
	"returns the cost of an Item instance"

	^ cost! !

!Item methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 18:48'!
slot
	"returns the slot of an Item instance"

	^ slot! !

!Item methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 18:52'!
cost: newCost
	"sets the cost of an Item instance"

	cost := newCost! !

!Item methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 18:46'!
name
	"returns the name of an Item instance"

	^ name! !

!Item methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 18:50'!
slot: newSlot
	"sets the slot of an Item instance"

	slot := newSlot! !


Item subclass: #BattleFury
	instanceVariableNames: 'minDamage maxDamage mana'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!BattleFury commentStamp: '<historical>' prior: 0!
Represents BattleFury!


!BattleFury methodsFor: 'initialization' stamp: 'BerkErol 5/9/2017 18:50'!
initialize
	"Creates a new Battle Fury instance"

	super initialize.
	name := 'Battle Fury'.
	cost := 4500.
	slot := 1.
	minDamage := 55.
	maxDamage := 55.
	mana := 50! !


!BattleFury methodsFor: 'editing' stamp: 'BerkErol 5/9/2017 19:20'!
use: player
	"uses a Battle Fury for a Player instance"

	player effects minDamage: player effects minDamage + self minDamage.
	player effects maxDamage: player effects maxDamage + self maxDamage.
	player effects manaAlways: player effects manaAlways + self mana! !


!BattleFury methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:49'!
minDamage: anObject
	minDamage := anObject! !

!BattleFury methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 22:10'!
mana: anObject
	mana := anObject! !

!BattleFury methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:49'!
maxDamage
	^ maxDamage! !

!BattleFury methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:49'!
minDamage
	^ minDamage! !

!BattleFury methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:49'!
maxDamage: anObject
	maxDamage := anObject! !

!BattleFury methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 22:10'!
mana
	^ mana! !


Item subclass: #Butterfly
	instanceVariableNames: 'minDamage maxDamage evasion'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Butterfly commentStamp: '<historical>' prior: 0!
Represents Butterfly.!


!Butterfly methodsFor: 'initialization' stamp: 'BerkErol 5/9/2017 18:52'!
initialize
	"Creates a new Butterfly instance"

	super initialize.
	name := 'Butterfly'.
	cost := 5500.
	slot := 1.
	minDamage := 30.
	maxDamage := 30.
	self class count: self class count + 1.
	evasion := (self class evasion / self class count) rounded! !


!Butterfly methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:23'!
evasion: anObject
	evasion := anObject! !

!Butterfly methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:51'!
minDamage: anObject
	minDamage := anObject! !

!Butterfly methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:51'!
maxDamage
	^ maxDamage! !

!Butterfly methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:51'!
minDamage
	^ minDamage! !

!Butterfly methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:51'!
maxDamage: anObject
	maxDamage := anObject! !

!Butterfly methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:23'!
evasion
	^ evasion! !


!Butterfly methodsFor: 'editing' stamp: 'BerkErol 5/9/2017 18:52'!
use: player
	"uses a Butterfly for a Player instance"

	player effects minDamage: player effects minDamage + self minDamage.
	player effects maxDamage: player effects maxDamage + self maxDamage.
	player effects evasion: player effects evasion + self evasion! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Butterfly class
	instanceVariableNames: 'count evasion'!

!Butterfly class methodsFor: 'initialization' stamp: 'BerkErol 5/7/2017 21:59'!
initialize
	"Initializes Butterfly class"

	count := 0.
	evasion := 25! !


!Butterfly class methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:23'!
count: anObject
	count := anObject! !

!Butterfly class methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:23'!
evasion: anObject
	evasion := anObject! !

!Butterfly class methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:23'!
count
	^ count! !

!Butterfly class methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:23'!
evasion
	^ evasion! !


Item subclass: #Daedalus
	instanceVariableNames: 'minDamage maxDamage critic'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Daedalus commentStamp: '<historical>' prior: 0!
Represents Daedalus.!


!Daedalus methodsFor: 'editing' stamp: 'BerkErol 5/9/2017 18:53'!
use: player
	"uses a Daedalus for a Player instance"

	player effects minDamage: player effects minDamage + self minDamage.
	player effects maxDamage: player effects maxDamage + self maxDamage.
	player effects critic: player effects critic + self critic! !


!Daedalus methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:52'!
minDamage: anObject
	minDamage := anObject! !

!Daedalus methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:50'!
critic
	^ critic! !

!Daedalus methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:52'!
maxDamage
	^ maxDamage! !

!Daedalus methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:52'!
minDamage
	^ minDamage! !

!Daedalus methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:50'!
critic: anObject
	critic := anObject! !

!Daedalus methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:52'!
maxDamage: anObject
	maxDamage := anObject! !


!Daedalus methodsFor: 'initialization' stamp: 'BerkErol 5/9/2017 18:53'!
initialize
	"Creates a new Daedalus instance"

	super initialize.
	name := 'Daedalus'.
	cost := 5500.
	slot := 1.
	minDamage := 75.
	maxDamage := 75.
	self class count: self class count + 1.
	critic := (self class critic / self class count) rounded! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Daedalus class
	instanceVariableNames: 'count critic'!

!Daedalus class methodsFor: 'initialization' stamp: 'BerkErol 5/7/2017 21:58'!
initialize
	"Initializes Daedalus class"

	count := 0.
	critic := 25! !


!Daedalus class methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:48'!
count: anObject
	count := anObject! !

!Daedalus class methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:48'!
critic
	^ critic! !

!Daedalus class methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:48'!
count
	^ count! !

!Daedalus class methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:48'!
critic: anObject
	critic := anObject! !


Item subclass: #Desolator
	instanceVariableNames: 'minDamage maxDamage armor'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Desolator commentStamp: '<historical>' prior: 0!
Represents Desolator.!


!Desolator methodsFor: 'editing' stamp: 'BerkErol 5/9/2017 18:55'!
use: player
	"uses a Desolator for a Player instance"

	player effects minDamage: player effects minDamage + self minDamage.
	player effects maxDamage: player effects maxDamage + self maxDamage.
	player effects critic: player effects armor + self armor! !


!Desolator methodsFor: 'initialization' stamp: 'BerkErol 5/9/2017 18:57'!
initialize
	"Creates a new Desolator instance"

	super initialize.
	name := 'Desolator'.
	cost := 4000.
	slot := 1.
	minDamage := 50.
	maxDamage := 50.
	armor := -5! !


!Desolator methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:56'!
minDamage: anObject
	minDamage := anObject! !

!Desolator methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:56'!
maxDamage
	^ maxDamage! !

!Desolator methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:56'!
minDamage
	^ minDamage! !

!Desolator methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:56'!
maxDamage: anObject
	maxDamage := anObject! !

!Desolator methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:56'!
armor
	^ armor! !

!Desolator methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:56'!
armor: anObject
	armor := anObject! !


Item subclass: #EnergyBooster
	instanceVariableNames: 'mana'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!EnergyBooster commentStamp: '<historical>' prior: 0!
Represents Energy Booster.!


!EnergyBooster methodsFor: 'initialization' stamp: 'BerkErol 5/9/2017 19:21'!
initialize
	"Creates a new Energy Booster instance"

	super initialize.
	name := 'Energy Booster'.
	cost := 1100.
	slot := 1.
	mana := 250! !


!EnergyBooster methodsFor: 'editing' stamp: 'BerkErol 5/9/2017 19:21'!
use: player
	"uses an Energy Booster for a Player instance"

	player effects mana: player effects mana + self mana! !


!EnergyBooster methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 19:21'!
mana: anObject
	mana := anObject! !

!EnergyBooster methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 19:21'!
mana
	^ mana! !


Item subclass: #HealthPotion
	instanceVariableNames: 'hp'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!HealthPotion commentStamp: '<historical>' prior: 0!
Represents Health Potion.!


!HealthPotion methodsFor: 'initialization' stamp: 'BerkErol 5/9/2017 19:36'!
initialize
	"Creates a new Health Potion instance"

	super initialize.
	name := 'Health Potion'.
	cost := 200.
	slot := 0.5.
	hp := 300! !


!HealthPotion methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 19:36'!
hp: anObject
	hp := anObject! !

!HealthPotion methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 19:36'!
hp
	^ hp! !


Item subclass: #HeartOfTarrasque
	instanceVariableNames: 'hp hp7p'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!HeartOfTarrasque commentStamp: '<historical>' prior: 0!
Represents Heart of Tarrasque.!


!HeartOfTarrasque methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 19:03'!
hp
	^ hp! !

!HeartOfTarrasque methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 19:03'!
hp: anObject
	hp := anObject! !

!HeartOfTarrasque methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 22:18'!
hp7p: anObject
	hp7p := anObject! !

!HeartOfTarrasque methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 22:18'!
hp7p
	^ hp7p! !


!HeartOfTarrasque methodsFor: 'editing' stamp: 'BerkErol 5/9/2017 19:05'!
use: player
	"uses a Heart of Tarrasque for a Player instance"

	player effects hp: player effects hp + self hp.
	player effects hp7p: player effects hp7p + self hp7p! !


!HeartOfTarrasque methodsFor: 'initialization' stamp: 'BerkErol 5/9/2017 19:04'!
initialize
	"Creates a new Heart of Tarrasque instance"

	super initialize.
	name := 'Heart of Tarrasque'.
	cost := 5600.
	slot := 1.
	hp := 250.
	hp7p := 1! !


Item subclass: #HoodOfDefiance
	instanceVariableNames: 'decSkill'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!HoodOfDefiance commentStamp: '<historical>' prior: 0!
Represents Hood of Defiance.!


!HoodOfDefiance methodsFor: 'editing' stamp: 'BerkErol 5/7/2017 22:26'!
use: player
	"uses a Hood of Defiance for a Player instance"

	player effects decSkill: player effects decSkill + self decSkill! !


!HoodOfDefiance methodsFor: 'initialization' stamp: 'BerkErol 5/7/2017 22:25'!
initialize
	"Creates a new Hood of Defiance instance"

	super initialize.
	name := 'Hood of Defiance'.
	cost := 2000.
	slot := 1.
	decSkill := 25! !


!HoodOfDefiance methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 22:25'!
decSkill
	^ decSkill! !

!HoodOfDefiance methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 22:25'!
decSkill: anObject
	decSkill := anObject! !


GameArena subclass: #ItemEffects
	instanceVariableNames: 'minDamage maxDamage armor hp mana manaAlways evasion critic hp7p decSkill dec60'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!ItemEffects commentStamp: '<historical>' prior: 0!
Represents continuous item effects!


!ItemEffects methodsFor: 'initialization' stamp: 'BerkErol 5/15/2017 20:36'!
initialize
	"Creates a new ItemEffects instance"

	minDamage := 0.
	maxDamage := 0.
	armor := 0.
	hp := 0.
	mana := 0.
	manaAlways := 0.
	evasion := 0.
	critic := 0.
	hp7p := 0.
	decSkill := 0.
	dec60 := 0! !


!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 19:20'!
manaAlways
	^ manaAlways! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:48'!
minDamage: anObject
	minDamage := anObject! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 19:20'!
mana
	^ mana! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:32'!
evasion
	^ evasion! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 19:20'!
mana: anObject
	mana := anObject! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:48'!
maxDamage: anObject
	maxDamage := anObject! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 22:15'!
hp7p
	^ hp7p! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:48'!
hp: anObject
	hp := anObject! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:51'!
critic
	^ critic! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:54'!
armor: anObject
	armor := anObject! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:48'!
minDamage
	^ minDamage! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:53'!
dec60
	^ dec60! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:48'!
maxDamage
	^ maxDamage! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 22:23'!
decSkill: anObject
	decSkill := anObject! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:54'!
armor
	^ armor! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 19:20'!
manaAlways: anObject
	manaAlways := anObject! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 22:15'!
hp7p: anObject
	hp7p := anObject! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:53'!
dec60: anObject
	dec60 := anObject! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 22:23'!
decSkill
	^ decSkill! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:32'!
evasion: anObject
	evasion := anObject! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 18:48'!
hp
	^ hp! !

!ItemEffects methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:51'!
critic: anObject
	critic := anObject! !


Item subclass: #ManaPotion
	instanceVariableNames: 'mana'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!ManaPotion commentStamp: '<historical>' prior: 0!
Represents Mana Potion.!


!ManaPotion methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 19:37'!
mana: anObject
	mana := anObject! !

!ManaPotion methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 19:37'!
mana
	^ mana! !


!ManaPotion methodsFor: 'initialization' stamp: 'BerkErol 5/9/2017 19:37'!
initialize
	"Creates a new Mana Potion instance"

	super initialize.
	name := 'Mana Potion'.
	cost := 200.
	slot := 0.5.
	mana := 300! !


GameArena subclass: #Player
	instanceVariableNames: 'name inventory fight effects'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Player commentStamp: 'BerkErol 4/19/2017 20:16' prior: 0!
Represents players.!


!Player methodsFor: 'initialization' stamp: 'BerkErol 5/7/2017 21:34'!
initialize
	"Creates a new Player instance"

	super initialize.
	inventory := Inventory new.
	fight := Fight new.
	effects := ItemEffects new! !


!Player methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 22:58'!
inventory
	"returns the inventory of a Player instance"

	^ inventory! !

!Player methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 20:29'!
name: newName
	"sets the name of a Player instance"

	name := newName! !

!Player methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 22:55'!
fight
	"returns the fight of a Player instance"

	^ fight! !

!Player methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 20:29'!
name
	"returns the name of a Player instance"

	^ name! !

!Player methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 22:56'!
fight: newFight
	"sets the fight of a Player instance"

	fight := newFight! !

!Player methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:34'!
effects: anObject
	effects := anObject! !

!Player methodsFor: 'accessing' stamp: 'BerkErol 4/19/2017 22:58'!
inventory: newInventory
	"sets the inventory of a Player instance"

	inventory := newInventory! !

!Player methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:34'!
effects
	^ effects! !


Hero subclass: #Scourge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Scourge commentStamp: 'BerkErol 4/19/2017 11:16' prior: 0!
Represents Scourge heroes.!


!Scourge methodsFor: 'initialization' stamp: 'BerkErol 4/19/2017 11:26'!
initialize
	"Creates a new Scourge instance"

	super initialize.
	side := 'Scourge'! !


!Scourge methodsFor: 'editing' stamp: 'BerkErol 5/1/2017 13:01'!
attack
	"calculates given damage"

	^ super attack! !


Scourge subclass: #Leshrac
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Leshrac commentStamp: '<historical>' prior: 0!
Represents Leschrac.!


!Leshrac methodsFor: 'initialization' stamp: 'BerkErol 4/20/2017 18:32'!
initialize
	"Creates a new Leshrac instance"

	super initialize.
	name := 'Leshrac'.
	hp := 1518.
	mana := 1534.
	armor := 12.
	skill1 := SplitEarth new.
	skill2 := PulseNova new.
	minDamage := 133.
	maxDamage := 137! !


Scourge subclass: #Lion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Lion commentStamp: '<historical>' prior: 0!
Represents Lion.!


!Lion methodsFor: 'initialization' stamp: 'BerkErol 4/20/2017 18:33'!
initialize
	"Creates a new Lion instance"

	super initialize.
	name := 'Lion'.
	hp := 1609.
	mana := 1456.
	armor := 9.
	skill1 := EarthSpike new.
	skill2 := FingerOfDeath new.
	minDamage := 139.
	maxDamage := 145! !


Scourge subclass: #Mortred
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Mortred commentStamp: '<historical>' prior: 0!
Represents Mortred.!


!Mortred methodsFor: 'editing' stamp: 'BerkErol 5/1/2017 13:28'!
attack
	"calculates given damage"

	(Random new nextInt: 100) <= 15
		ifTrue: [ ^ super attack * 4 ]
		ifFalse: [ ^ super attack ]! !


!Mortred methodsFor: 'initialization' stamp: 'BerkErol 4/20/2017 18:36'!
initialize
	"Creates a new Mortred instance"

	super initialize.
	name := 'Mortred'.
	hp := 1754.
	mana := 892.
	armor := 18.
	skill1 := Blur new.
	skill2 := CoupDeGrace new.
	minDamage := 142.
	maxDamage := 144! !


Scourge subclass: #NyxAssassin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!NyxAssassin commentStamp: '<historical>' prior: 0!
Represents Nyx Assassin.!


!NyxAssassin methodsFor: 'initialization' stamp: 'BerkErol 4/20/2017 18:39'!
initialize
	"Creates a new Nyx Assassin instance"

	super initialize.
	name := 'Nyx Assassin'.
	hp := 1784.
	mana := 1149.
	armor := 14.
	skill1 := Impale new.
	skill2 := ManaBurn new.
	minDamage := 122.
	maxDamage := 126! !


Hero subclass: #Sentinel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Sentinel commentStamp: 'BerkErol 4/19/2017 11:16' prior: 0!
Represents Sentinel heroes.!


!Sentinel methodsFor: 'initialization' stamp: 'BerkErol 4/19/2017 11:26'!
initialize
	"Creates a new Sentinel instance"

	super initialize.
	side := 'Sentinel'! !


Sentinel subclass: #Earthshaker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Earthshaker commentStamp: '<historical>' prior: 0!
Represents Earthshaker.!


!Earthshaker methodsFor: 'initialization' stamp: 'BerkErol 4/20/2017 18:42'!
initialize
	"Creates a new Earthshaker instance"

	super initialize.
	name := 'Earthshaker'.
	hp := 2270.
	mana := 1030.
	armor := 10.
	skill1 := Fissure new.
	skill2 := EnchantTotem new.
	minDamage := 136.
	maxDamage := 146! !


Sentinel subclass: #Magina
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Magina commentStamp: '<historical>' prior: 0!
Represents Magina.!


!Magina methodsFor: 'initialization' stamp: 'BerkErol 4/20/2017 18:44'!
initialize
	"Creates a new Magina instance"

	super initialize.
	name := 'Magina'.
	hp := 1495.
	mana := 1017.
	armor := 14.
	skill1 := ManaBreak new.
	skill2 := ManaVoid new.
	minDamage := 136.
	maxDamage := 140! !


Sentinel subclass: #Mirana
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Mirana commentStamp: '<historical>' prior: 0!
Represents Mirana.!


!Mirana methodsFor: 'initialization' stamp: 'BerkErol 4/20/2017 18:45'!
initialize
	"Creates a new Mirana instance"

	super initialize.
	name := 'Mirana'.
	hp := 1697.
	mana := 996.
	armor := 16.
	skill1 := Starstorm new.
	skill2 := SacredArrow new.
	minDamage := 137.
	maxDamage := 148! !


Sentinel subclass: #OgreMagi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!OgreMagi commentStamp: '<historical>' prior: 0!
Represents Ogre Magi.!


!OgreMagi methodsFor: 'initialization' stamp: 'BerkErol 4/20/2017 18:45'!
initialize
	"Creates a new Ogre Magi instance"

	super initialize.
	name := 'Ogre Magi'.
	hp := 2426.
	mana := 1105.
	armor := 16.
	skill1 := Fireblast new.
	skill2 := Multicast new.
	minDamage := 126.
	maxDamage := 132! !


Sentinel subclass: #Rylai
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Rylai commentStamp: '<historical>' prior: 0!
Represents Rylai.!


!Rylai methodsFor: 'initialization' stamp: 'BerkErol 4/20/2017 18:46'!
initialize
	"Creates a new Rylai instance"

	super initialize.
	name := 'Rylai'.
	hp := 1609.
	mana := 1373.
	armor := 9.
	skill1 := FrostBite new.
	skill2 := FreezingField new.
	minDamage := 125.
	maxDamage := 131! !


Scourge subclass: #SkeletonKing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!SkeletonKing commentStamp: '<historical>' prior: 0!
Represents Skeleton King.!


!SkeletonKing methodsFor: 'initialization' stamp: 'BerkErol 4/20/2017 18:40'!
initialize
	"Creates a new Skeleton King instance"

	super initialize.
	name := 'Skeleton King'.
	hp := 2270.
	mana := 993.
	armor := 11.
	skill1 := WraithfireBlast new.
	skill2 := VampiricAura new.
	minDamage := 151.
	maxDamage := 153! !


Dota subclass: #Skill
	instanceVariableNames: 'name type count cooldown mana'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Skill commentStamp: '<historical>' prior: 0!
Represents skills.!


!Skill methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:31'!
initialize
	"Creates a new Skill instance"

	super initialize.
	count := 0! !


!Skill methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 18:48'!
count
	"returns the count of a Skill instance"

	^ count! !

!Skill methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 18:26'!
mana
	"returns the mana of a Skill instance"

	^ mana! !

!Skill methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 18:28'!
name
	"returns the name of a Skill instance"

	^ name! !

!Skill methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 18:28'!
type
	"returns the type of a Skill instance"

	^ type! !

!Skill methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 18:30'!
cooldown: newCooldown
	"sets the cooldown of a Skill instance"

	cooldown := newCooldown! !

!Skill methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 18:28'!
name: newName
	"sets the name of a Skill instance"

	name := newName! !

!Skill methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 18:49'!
count: newCount
	"sets the count of a Skill instance"

	count := newCount! !

!Skill methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 18:30'!
cooldown
	"returns the cooldown of a Skill instance"

	^ cooldown! !

!Skill methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 18:29'!
type: newType
	"sets the type of a Skill instance"

	type := newType! !

!Skill methodsFor: 'accessing' stamp: 'BerkErol 4/20/2017 18:26'!
mana: newMana
	"sets the mana of a Skill instance"

	mana := newMana! !


Skill subclass: #AnchorSmash
	instanceVariableNames: 'defense dcount duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!AnchorSmash commentStamp: '<historical>' prior: 0!
Represents Anchor Smash.!


!AnchorSmash methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:41'!
duration: anObject
	duration := anObject! !

!AnchorSmash methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:41'!
defense
	^ defense! !

!AnchorSmash methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:41'!
dcount: anObject
	dcount := anObject! !

!AnchorSmash methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:41'!
duration
	^ duration! !

!AnchorSmash methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:41'!
defense: anObject
	defense := anObject! !

!AnchorSmash methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:41'!
dcount
	^ dcount! !


!AnchorSmash methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:42'!
use: enemyPlayer
	"Returns effects of Anchor Smash"

	dcount := duration.
	^ #(225 0)! !


!AnchorSmash methodsFor: 'initialization' stamp: 'BerkErol 5/16/2017 00:51'!
initialize
	"Creates a new Anchor Smash instance"

	super initialize.
	name := 'Anchor Smash'.
	type := true.
	cooldown := 3.
	mana := 60.
	defense := 0.4.
	dcount := 0.
	duration := 1! !


Skill subclass: #Blur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Blur commentStamp: '<historical>' prior: 0!
Represents Blur.!


!Blur methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:26'!
initialize
	"Creates a new Blur instance"

	super initialize.
	name := 'Blur'.
	type := false.
	cooldown := 0.
	mana := 0! !


Skill subclass: #CoupDeGrace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!CoupDeGrace commentStamp: '<historical>' prior: 0!
Represents Coup de Grace.!


!CoupDeGrace methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:27'!
initialize
	"Creates a new Coup de Grace instance"

	super initialize.
	name := 'Coup de Grace'.
	type := false.
	cooldown := 0.
	mana := 0! !


Skill subclass: #EarthSpike
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!EarthSpike commentStamp: '<historical>' prior: 0!
Represents Earth Spike.!


!EarthSpike methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:27'!
initialize
	"Creates a new Earth Spike instance"

	super initialize.
	name := 'Earth Spike'.
	type := true.
	cooldown := 5.
	mana := 160! !


!EarthSpike methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:19'!
use: enemyPlayer
	"Returns effects of Earth Spike"

	^ #(260 0)! !


Skill subclass: #EnchantTotem
	instanceVariableNames: 'damage dcount duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!EnchantTotem commentStamp: '<historical>' prior: 0!
Represents Enchant Totem.!


!EnchantTotem methodsFor: 'initialization' stamp: 'BerkErol 5/16/2017 00:15'!
initialize
	"Creates a new Enchant Totem instance"

	super initialize.
	name := 'Enchant Totem'.
	type := true.
	cooldown := 5.
	mana := 50.
	damage := 4.
	dcount := 0.
	duration := 1! !


!EnchantTotem methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:20'!
use: enemyPlayer
	"Returns effects of Enchant Totem"

	dcount := duration.
	^ #(0 0)! !


!EnchantTotem methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:15'!
dcount
	^ dcount! !

!EnchantTotem methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:12'!
damage: anObject
	damage := anObject! !

!EnchantTotem methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:12'!
duration
	^ duration! !

!EnchantTotem methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:15'!
dcount: anObject
	dcount := anObject! !

!EnchantTotem methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:12'!
damage
	^ damage! !

!EnchantTotem methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:12'!
duration: anObject
	duration := anObject! !


Skill subclass: #FingerOfDeath
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!FingerOfDeath commentStamp: '<historical>' prior: 0!
Represents Finger of Death.!


!FingerOfDeath methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:20'!
use: enemyPlayer
	"Returns effects of Finger of Death"

	^ #(850 0)! !


!FingerOfDeath methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:27'!
initialize
	"Creates a new Finger of Death instance"

	super initialize.
	name := 'Finger of Death'.
	type := true.
	cooldown := 8.
	mana := 650! !


Skill subclass: #Fireblast
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Fireblast commentStamp: '<historical>' prior: 0!
Represents Fireblast.!


!Fireblast methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:20'!
use: enemyPlayer
	"Returns effects of Fireblast"

	| random |
	random := Random new nextInt: 100.
	random <= 13
		ifTrue: [ ^ #(880 0) ]
		ifFalse: [ random <= 25
				ifTrue: [ ^ #(660 0) ]
				ifFalse: [ random <= 60
						ifTrue: [ ^ #(440 0) ]
						ifFalse: [ ^ #(220 0) ] ] ]! !


!Fireblast methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:27'!
initialize
	"Creates a new Fireblast instance"

	super initialize.
	name := 'Fireblast'.
	type := true.
	cooldown := 5.
	mana := 225! !


Skill subclass: #Fissure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Fissure commentStamp: '<historical>' prior: 0!
Represents Fissure.!


!Fissure methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:26'!
initialize
	"Creates a new Fissure instance"

	super initialize.
	name := 'Fissure'.
	type := true.
	cooldown := 5.
	mana := 170! !


!Fissure methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:20'!
use: enemyPlayer
	"Returns effects of Fissure"

	^ #(260 0)! !


Skill subclass: #FreezingField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!FreezingField commentStamp: '<historical>' prior: 0!
Represents Freezing Field.!


!FreezingField methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:20'!
use: enemyPlayer
	"Returns effects of Freezing Field"

	^ #(800 0)! !


!FreezingField methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:27'!
initialize
	"Creates a new Freezing Field instance"

	super initialize.
	name := 'Freezing Field'.
	type := true.
	cooldown := 8.
	mana := 600! !


Skill subclass: #FrostBite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!FrostBite commentStamp: '<historical>' prior: 0!
Represents Frost Bite.!


!FrostBite methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:21'!
use: enemyPlayer
	"Returns effects of Frost Bite"

	^ #(300 0)! !


!FrostBite methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:27'!
initialize
	"Creates a new Frost Bite instance"

	super initialize.
	name := 'Frost Bite'.
	type := true.
	cooldown := 5.
	mana := 150! !


Skill subclass: #GodsStrength
	instanceVariableNames: 'damage dcount duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!GodsStrength commentStamp: '<historical>' prior: 0!
Represents God’s Strength.!


!GodsStrength methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:21'!
use: enemyPlayer
	"Returns effects of God's Strength"

	dcount := duration.
	^ #(0 0)! !


!GodsStrength methodsFor: 'initialization' stamp: 'BerkErol 5/16/2017 00:16'!
initialize
	"Creates a new God’s Strength instance"

	super initialize.
	name := 'Gods Strength'.
	type := true.
	cooldown := 5.
	mana := 200.
	damage := 2.
	dcount := 0.
	duration := 3! !


!GodsStrength methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:16'!
dcount
	^ dcount! !

!GodsStrength methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:13'!
damage: anObject
	damage := anObject! !

!GodsStrength methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:13'!
duration
	^ duration! !

!GodsStrength methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:16'!
dcount: anObject
	dcount := anObject! !

!GodsStrength methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:13'!
damage
	^ damage! !

!GodsStrength methodsFor: 'accessing' stamp: 'BerkErol 5/16/2017 00:13'!
duration: anObject
	duration := anObject! !


Skill subclass: #Impale
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Impale commentStamp: '<historical>' prior: 0!
Represents Impale.!


!Impale methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:21'!
use: enemyPlayer
	"Returns effects of Impale"

	^ #(260 0)! !


!Impale methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:27'!
initialize
	"Creates a new Impale instance"

	super initialize.
	name := 'Impale'.
	type := true.
	cooldown := 5.
	mana := 225! !


Skill subclass: #ManaBreak
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!ManaBreak commentStamp: '<historical>' prior: 0!
Represents Mana Break.!


!ManaBreak methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:28'!
initialize
	"Creates a new Mana Break instance"

	super initialize.
	name := 'Mana Break'.
	type := false.
	cooldown := 0.
	mana := 0! !


Skill subclass: #ManaBurn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!ManaBurn commentStamp: '<historical>' prior: 0!
Represents Mana Burn.!


!ManaBurn methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:28'!
initialize
	"Creates a new Mana Burn instance"

	super initialize.
	name := 'Mana Burn'.
	type := true.
	cooldown := 5.
	mana := 50! !


!ManaBurn methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:21'!
use: enemyPlayer
	"Returns effects of Mana Burn"

	| array dec |
	array := Array new: 2.
	dec := (enemyPlayer fight mana / 5) rounded.
	array at: 1 put: 0.
	array at: 2 put: dec.
	^ array! !


Skill subclass: #ManaVoid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!ManaVoid commentStamp: '<historical>' prior: 0!
Represents Mana Void.!


!ManaVoid methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:22'!
use: enemyPlayer
	"Returns effects of Mana Void"

	| array dec |
	array := Array new: 2.
	dec := (1.1 * (enemyPlayer fight hero mana - enemyPlayer fight mana)) rounded.
	array at: 1 put: dec.
	array at: 2 put: 0.
	^ array! !


!ManaVoid methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:28'!
initialize
	"Creates a new Mana Void instance"

	super initialize.
	name := 'Mana Void'.
	type := true.
	cooldown := 7.
	mana := 275! !


Skill subclass: #Multicast
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Multicast commentStamp: '<historical>' prior: 0!
Represents Multicast.!


!Multicast methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:28'!
initialize
	"Creates a new Multicast instance"

	super initialize.
	name := 'Multicast'.
	type := false.
	cooldown := 0.
	mana := 0! !


Skill subclass: #PulseNova
	instanceVariableNames: 'damage'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!PulseNova commentStamp: '<historical>' prior: 0!
Represents Pulse Nova.!


!PulseNova methodsFor: 'editing' stamp: 'BerkErol 5/15/2017 22:08'!
deactivate
	"deactivates Pulse Nova"

	type := false! !

!PulseNova methodsFor: 'editing' stamp: 'BerkErol 5/15/2017 21:28'!
activate
	"Activates Pulse Nova"

	type := true! !


!PulseNova methodsFor: 'accessing' stamp: 'BerkErol 5/15/2017 21:29'!
damage: anObject
	damage := anObject! !

!PulseNova methodsFor: 'accessing' stamp: 'BerkErol 5/15/2017 21:29'!
damage
	^ damage! !


!PulseNova methodsFor: 'initialization' stamp: 'BerkErol 5/15/2017 21:30'!
initialize
	"Creates a new Pulse Nova instance"

	super initialize.
	name := 'Pulse Nova'.
	type := false.
	cooldown := 0.
	mana := 150.
	damage := 50! !


Skill subclass: #Ravage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Ravage commentStamp: '<historical>' prior: 0!
Represents Ravage.!


!Ravage methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:29'!
initialize
	"Creates a new Ravage instance"

	super initialize.
	name := 'Ravage'.
	type := true.
	cooldown := 10.
	mana := 325! !


!Ravage methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:22'!
use: enemyPlayer
	"Returns effects of Ravage"

	^ #(380 0)! !


Skill subclass: #SacredArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!SacredArrow commentStamp: '<historical>' prior: 0!
Represents Sacred Arrow.!


!SacredArrow methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:29'!
initialize
	"Creates a new Sacred Arrow instance"

	super initialize.
	name := 'Sacred Arrow'.
	type := true.
	cooldown := 4.
	mana := 100! !


!SacredArrow methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:22'!
use: enemyPlayer
	"Returns effects of Sacred Arrow"

	(Random new nextInt: 100) <= 75
		ifTrue: [ ^ #(320 0) ]
		ifFalse: [ ^ #(0 0) ]! !


Skill subclass: #SplitEarth
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!SplitEarth commentStamp: '<historical>' prior: 0!
Represents Split Earth.!


!SplitEarth methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:29'!
initialize
	"Creates a new Split Earth instance"

	super initialize.
	name := 'Split Earth'.
	type := true.
	cooldown := 5.
	mana := 160! !


!SplitEarth methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:23'!
use: enemyPlayer
	"Returns effects of Split Earth"

	^ #(300 0)! !


Skill subclass: #Starstorm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Starstorm commentStamp: 'BerkErol 4/20/2017 17:34' prior: 0!
Represents Starstorm.!


!Starstorm methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:29'!
initialize
	"Creates a new Starstorm instance"

	super initialize.
	name := 'Starstorm'.
	type := true.
	cooldown := 4.
	mana := 160! !


!Starstorm methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:23'!
use: enemyPlayer
	"Returns effects of Starstorm"

	^ #(300 0)! !


Skill subclass: #StormHammer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!StormHammer commentStamp: '<historical>' prior: 0!
Represents Storm Hammer.!


!StormHammer methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:29'!
initialize
	"Creates a new Storm Hammer instance"

	super initialize.
	name := 'Storm Hammer'.
	type := true.
	cooldown := 5.
	mana := 140! !


!StormHammer methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:24'!
use: enemyPlayer
	"Returns effects of Storm Hammer"

	^ #(325 0)! !


Sentinel subclass: #Sven
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Sven commentStamp: '<historical>' prior: 0!
Represents Sven.!


!Sven methodsFor: 'initialization' stamp: 'BerkErol 4/20/2017 18:47'!
initialize
	"Creates a new Sven instance"

	super initialize.
	name := 'Sven'.
	hp := 2198.
	mana := 874.
	armor := 14.
	skill1 := StormHammer new.
	skill2 := GodsStrength new.
	minDamage := 149.
	maxDamage := 151! !


Scourge subclass: #Tidehunter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Tidehunter commentStamp: '<historical>' prior: 0!
Represents Tidehunter.!


!Tidehunter methodsFor: 'initialization' stamp: 'BerkErol 4/20/2017 18:41'!
initialize
	"Creates a new Tidehunter instance"

	super initialize.
	name := 'Tidehunter'.
	hp := 2316.
	mana := 998.
	armor := 11.
	skill1 := AnchorSmash new.
	skill2 := Ravage new.
	minDamage := 139.
	maxDamage := 145! !


Skill subclass: #VampiricAura
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!VampiricAura commentStamp: '<historical>' prior: 0!
Represents Vampiric Aura.!


!VampiricAura methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:29'!
initialize
	"Creates a new Vampiric Aura instance"

	super initialize.
	name := 'Vampiric Aura'.
	type := false.
	cooldown := 0.
	mana := 0! !


Item subclass: #Vanguard
	instanceVariableNames: 'hp dec60'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!Vanguard commentStamp: '<historical>' prior: 0!
Represents Vanguard.!


!Vanguard methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:56'!
dec60: anObject
	dec60 := anObject! !

!Vanguard methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 19:06'!
hp: anObject
	hp := anObject! !

!Vanguard methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 19:06'!
hp
	^ hp! !

!Vanguard methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:56'!
dec60
	^ dec60! !


!Vanguard methodsFor: 'editing' stamp: 'BerkErol 5/9/2017 19:06'!
use: player
	"uses a Vanguard for a Player instance"

	player effects hp: player effects hp + self hp.
	player effects dec60: player effects dec60 + self dec60! !


!Vanguard methodsFor: 'initialization' stamp: 'BerkErol 5/9/2017 19:06'!
initialize
	"Creates a new Vanguard instance"

	super initialize.
	name := 'Vanguard'.
	cost := 2500.
	slot := 1.
	hp := 250.
	self class count: self class count + 1.
	dec60 := (self class dec60 / self class count) rounded! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Vanguard class
	instanceVariableNames: 'count dec60'!

!Vanguard class methodsFor: 'initialization' stamp: 'BerkErol 5/7/2017 21:58'!
initialize
	"Initializes Vanguard class"

	count := 0.
	dec60 := 20! !


!Vanguard class methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:54'!
count: anObject
	count := anObject! !

!Vanguard class methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:54'!
dec60: anObject
	dec60 := anObject! !

!Vanguard class methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:54'!
dec60
	^ dec60! !

!Vanguard class methodsFor: 'accessing' stamp: 'BerkErol 5/7/2017 21:54'!
count
	^ count! !


Item subclass: #VitalityBooster
	instanceVariableNames: 'hp'
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!VitalityBooster commentStamp: 'BerkErol 4/27/2017 22:41' prior: 0!
Represents Vitality Booster.!


!VitalityBooster methodsFor: 'initialization' stamp: 'BerkErol 5/9/2017 19:07'!
initialize
	"Creates a new Vitality Booster instance"

	super initialize.
	name := 'Vitality Booster'.
	cost := 1200.
	slot := 1.
	hp := 250! !


!VitalityBooster methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 19:07'!
hp: anObject
	hp := anObject! !

!VitalityBooster methodsFor: 'accessing' stamp: 'BerkErol 5/9/2017 19:07'!
hp
	^ hp! !


!VitalityBooster methodsFor: 'editing' stamp: 'BerkErol 5/9/2017 19:07'!
use: player
	"uses a Vitality Booster for a Player instance"

	player effects hp: player effects hp + self hp! !


Skill subclass: #WraithfireBlast
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '2014400189'!
!WraithfireBlast commentStamp: 'BerkErol 4/20/2017 17:35' prior: 0!
Represents Wraithfire Blast.!


!WraithfireBlast methodsFor: 'initialization' stamp: 'BerkErol 4/21/2017 18:29'!
initialize
	"Creates a new Wraithfire Blast instance"

	super initialize.
	name := 'Wraithfire Blast'.
	type := true.
	cooldown := 5.
	mana := 140! !


!WraithfireBlast methodsFor: 'editing' stamp: 'BerkErol 5/16/2017 00:24'!
use: enemyPlayer
	"Returns effects of Wraithfire Blast"

	^ #(300 0)! !

Butterfly initialize!
Daedalus initialize!
Vanguard initialize!